// ****************************************
// *********   MapLoad (c) 2007 by Chrisber
// *********   Version: 2.0.0.0 Py
// *********   Release: 12/14/2007 21:00
// ****************************************
// *********   Forum: http://forums.mattie.info/cs/forums/viewtopic.php?t=18312
// *********   Addon: http://addons.eventscripts.com/addons/view/mapload
// ****************************************
// *********   EMail: admin@bmhost.de
// *********   WWW:   http://www.chaos-club.eu and http://www.chrisber.de
// ****************************************

import es

info = es.AddonInfo()
info.name     = "Mapload"
info.version  = "2.0.0.0 Py"
info.url      = "http://forums.mattie.info/cs/forums/viewtopic.php?t=18312"
info.basename = "mapload"
info.author   = "Chrisber aka ResistancY"

curmap = None
krand  = 0
xrand  = 0
script = None
unload = 0
map1   = None
map2   = None
map3   = None
map4   = None
map5   = None
map6   = None
map7   = None
map8   = None

def load():
	if not es.exists("command", "mapload"):
		es.regcmd("mapload", "mapload/mapload", "Load a script by the map(prefix)")
	
	if not es.exists("command", "mapunload"):
		es.regcmd("mapunload", "mapload/mapunload", "Unload a script which was loaded by mapload")
	
	if not es.exists("command", "portload"):
		es.regcmd("portload", "mapload/portload", "Load a script if the server has the defined port")
	
	if es.exists("keygroup", "mapload"):
		es.keygroupdelete("mapload")
	
	es.keygroupcreate("mapload")
	
	es.server.queuecmd("exec mapload.cfg")
	
	mapload = es.set("mapload", "2.0.0.0 Py")
	mapload.makepublic()
	

def unload():
	es.keygroupdelete("mapload")

def mapload():
	if es.getargc() > 2:
		krand = rand(0, 943867)
		
		es.keycreate("mapload", krand)
		es.keysetvalue("mapload", krand, "script", es.getargv(1))
		es.keysetvalue("mapload", krand, "unload", 0)
		es.keysetvalue("mapload", krand, "map1", es.getargv(2))
		es.keysetvalue("mapload", krand, "map2", es.getargv(3))
		es.keysetvalue("mapload", krand, "map3", es.getargv(4))
		es.keysetvalue("mapload", krand, "map4", es.getargv(5))
		es.keysetvalue("mapload", krand, "map5", es.getargv(6))
		es.keysetvalue("mapload", krand, "map6", es.getargv(7))
		es.keysetvalue("mapload", krand, "map7", es.getargv(8))
		es.keysetvalue("mapload", krand, "map8", es.getargv(9))
	else:
		es.dbgmsg(0, "Mapload: Not enough args; Syntax: mapload <script> <map1> [map2] [map3] [map4] [map5] [map6] [map7] [map8]")

def mapunload():
	if es.exists("key", "mapload", krand):
		es.keysetvalue("mapload", krand, "unload", 1)
	else:
		es.dbgmsg(0, "Mapload: Can't find a script to unload!")

def doload():
	if es.keygetvalue("mapload", xrand, "unload") == 1:
		es.unload(es.keygetvalue("mapload", xrand, "script"))
	
	i = 1
	while i < 9:
		if es.keygetvalue("mapload", xrand, "map" + i) in curmap:
			es.load(es.keygetvalue("mapload", xrand, "script")
			i = 9
		
		i = i + 1

def es_map_start(event_var):
	curmap = es.ServerVar("eventscripts_currentmap")
	curmap = curmap + ";"
	es.foreachkey("xrand", "in", "mapload", "es.doblock mapload/doload")

def portload():
	if es.getargc() > 2:
		if es.ServerVar("hostport") == es.getargv(2) or es.ServerVar("hostport") == es.getargv(3) or es.ServerVar("hostport") == es.getargv(4) or es.ServerVar("hostport") == es.getargv(5) or es.ServerVar("hostport") == es.getargv(6) or es.ServerVar("hostport") == es.getargv(7) or es.ServerVar("hostport") == es.getargv(8) or es.ServerVar("hostport") == es.getargv(9):
			es.load(es.getargv(1))
	else:
		es.dbgmsg(0, "Portload: Not enough args; Syntax: portload <script> <port1> [port2] [port3] [port4] [port5] [port6] [port7] [port8]")